import Option, { Some } from '../option.ts';
import {
	AbstractFileType,
	defaultHighlightOptions,
	FileLang,
	HighlightingOptions,
} from './base.ts';

export class CFile extends AbstractFileType {
	public override readonly name: FileLang = FileLang.C;
	public override readonly singleLineComment = Some('//');
	public override readonly multiLineCommentStart: Option<string> = Some('/*');
	public override readonly multiLineCommentEnd: Option<string> = Some('*/');
	public override readonly keywords1 = [
		'continue',
		'register',
		'restrict',
		'volatile',
		'default',
		'typedef',
		'typedef',
		'switch',
		'return',
		'static',
		'struct',
		'extern',
		'inline',
		'return',
		'sizeof',
		'switch',
		'break',
		'const',
		'while',
		'break',
		'union',
		'class',
		'union',
		'auto',
		'case',
		'else',
		'enum',
		'case',
		'for',
		'do',
		'if',
	];
	public override readonly keywords2 = [
		'#include',
		'unsigned',
		'uint32_t',
		'uint64_t',
		'uint16_t',
		'#define',
		'#ifndef',
		'wchar_t',
		'int32_t',
		'int64_t',
		'int16_t',
		'uint8_t',
		'double',
		'signed',
		'#endif',
		'#ifdef',
		'#error',
		'#undef',
		'int8_t',
		'time_t',
		'size_t',
		'float',
		'#elif',
		'long',
		'char',
		'void',
		'int',
		'#if',
	];
	public override readonly operators = [
		'>>>=',
		'**=',
		'&&=',
		'||=',
		'??=',
		'>>>',
		'<=>',
		'<<=',
		'>>=',
		'+=',
		'-=',
		'*=',
		'/=',
		'%=',
		'&=',
		'^=',
		'|=',
		'==',
		'!=',
		'>=',
		'<=',
		'++',
		'--',
		'**',
		'<<',
		'>>',
		'&&',
		'||',
		'??',
		'?.',
		'++',
		'--',
		'==',
		'!=',
		'>=',
		'<=',
		'&&',
		'||',
		'<<',
		'>>',
		'+=',
		'-=',
		'*=',
		'/=',
		'%=',
		'&=',
		'|=',
		'^=',
		'->',
		'::',
		'?',
		':',
		'=',
		'>',
		'<',
		'%',
		'-',
		'+',
		'*',
		'&',
		'|',
		'^',
		'~',
		'!',
		'.',
		',',
		';',
	];
	public override readonly hlOptions: HighlightingOptions = {
		...defaultHighlightOptions,
		characters: true,
		hexNumbers: true,
	};
}
